const path = require('path');
const child_process = require("child_process");
const fs = require("fs");
const mist = require('minimist');
const build = require("./chain")


function creat_argv() {
    let argv = mist(
        process.argv.slice(2),
        {
            alias: {
                'help':'h',
                'maxsize':'m',
                'always_with_else':'a'
            },
            boolean: [
                'always_with_else'
            ],
            default: {
                'maxsize':10000,
                'always_with_else':false
            }
        }
    );
    return(argv)
}


function usage () {
    console.log(
        `
  Usage: nv_if_chain  [options] 
  Options:
    -a, --always_with_else            always show else,default false
    -m, --maxsize                     the max-supported nodes,default 10000
    -h, --help                        Output usage information`
    )
   console.log("\n");
}


function run(k) {
    let argv = creat_argv();
    if (argv.help) {
        usage();
    } else {
        console.log(build(argv._,argv.m,argv.a))
    }
}

module.exports = run 

